package asd.td4;

/**
 * Une classe pour les exercices 1,2 et 3 de la feuille 4.
 *  2002 Marc Gatano
 */
public class Liste {

    private Object premier; // la valeur de la cellule
    private Liste  reste;   // la suite du chanage

    // Constructeurs

    /**
     * Construit une liste vide.
     */
    public Liste() {
        this.premier = null;
        this.reste = null;
    }

    /**
     * Construit une liste  un lment, l'objet x.
     */
    public Liste(Object x) {
        this(x,new Liste());
    }

    /**
     * Construit une liste dont le premier lment est l'objet x
     * et dont la suite est la liste l.
     */
    public Liste(Object x, Liste l) {
        this.premier = x;
        this.reste = l;
    }

    // Primitives

    public Object premier() {
        return premier;
    }

    public Liste reste() {
        return reste;
    }

    public void ajouter(Object x) {
        reste = new Liste(premier,reste);
        premier = x;
    }

    public void supprimer() {
        premier = reste.premier;
        reste   = reste.reste;
    }
    
    public boolean vide() {
        return reste == null;
    }

    // Non primitives

    /**
     * Retourne une chane de caractres reprsentant la liste.
     * Complexit : O(n) o n est le nombre d'lments de la liste.
     */
    public String toString() {
        if ( vide() ) {
            return "->";
        }
        String s = "-> " + premier();
        Liste l = reste();
        while ( ! l.vide() ) {
            s = s + " -> " + l.premier();
            l = l.reste();
        } 
        return s;
    }
        
    // NON-PRIMITIVES  CRIRE  l'AIDE DES PRIMITIVES

    /**
     * Retourne la longueur de la liste.
     */
    public int longueurIteratif() {
        return 0;
    }

    /**
     * Retourne la longueur de la liste.
     */
    public int longueurRecursif() {
        return 0;
    }

    /**
     * Retourne le i-ime lment de la liste. Si i > n o n est le
     * nombre d'lments de la liste, retourne le dernier lment de
     * la liste.
     * Prcondition : i > 0.et la liste n'est pas vide.
     */
    public Object elementIteratif(int i) {
        return null;
    }

    /**
     * Retourne le i-ime lment de la liste. Si i > n o n est le
     * nombre d'lments de la liste, retourne le dernier lment de
     * la liste.
     * Prcondition : i > 0.et la liste n'est pas vide.
     */
    public Object elementRecursif(int i) {
        return null;
    }

    /**
     * Retourne la position de la premire occurence de l'objet x
     * dans la liste (le premier lment de la liste tant  la
     * position 1). Si l'objet x n'est pas prsent dans la liste,
     * retourne 0.
     */
    public int positionIteratif(Object x) {
        return 0;
    }

    /**
     * Retourne la position de la premire occurence de l'objet x
     * dans la liste (le premier lment de la liste tant  la
     * position 1). Si l'objet x n'est pas prsent dans la liste,
     * retourne 0.
     */
    public int positionRecursif(Object x) {
        return 0;
    }

    /**
     * Ajoute l'objet x aprs le i-me lment de la liste.
     * Si i = 0, ajoute l'objet x en tte de la liste.
     * Si i > n o n est le nombre d'lments de la liste, ajoute
     * l'objet x  la fin de la liste.
     */
    public void ajouterIteratif(Object x, int i) {
    }

    /**
     * Ajoute l'objet x aprs le i-me lment de la liste.
     * Si i = 0, ajoute l'objet x en tte de la liste.
     * Si i > n o n est le nombre d'lments de la liste, ajoute
     * l'objet x  la fin de la liste.
     */
    public void ajouterRecursif(Object x, int i) {
    }

    /**
     * Supprime le i-ime lment de la liste.
     * Si i > n o n est le nombre d'lments de la liste, ne fait rien.
     */
    public void supprimerIteratif(int i) {
    }

    /**
     * Supprime le i-ime lment de la liste.
     * Si i > n o n est le nombre d'lments de la liste, ne fait rien.
     */
    public void supprimerRecursif(int i) {
    }
}
